/****************************************************************************

      Project     Template
      Autor:      Hitex/Lue/2008-02-05
      Company:    Hitex Development Tools GmbH
      Filename:   main.ld
      

***************************************************************************/
SEARCH_DIR( "$(ToolDir)\..\arm-hitex-elf\lib\thumb2" )

/* Path setting depends on the gnu compiler version */
/* Adjust the path here to the used version as necessary */
SEARCH_DIR("$(ToolDir)\..\lib\gcc\arm-hitex-elf\$(GNU_CORTEX_VERSION)\thumb2" )

INPUT (
   /* HiTOP will automatically put in here all object files to be linked.
      Leave this unchanged!                                               */
   $(LinkObjects)
)

/* Target Specific Parameters */

MEMORY
{
   FLASH (rx) : ORIGIN = 0x08000000, LENGTH = 128k
   SRAM (rwx) : ORIGIN = 0x20000000, LENGTH = 20k
}

/* Layout Information */
/* Section Definitions */
SECTIONS
{
   .text :
   {
      KEEP(*(vector vector.*))
      . = 0x164; 
	  __startup_code__ = .;
      $(TargetDir)startup.o (.text)         /* Startup code */
      /* $(TargetDir)*.o       (.text) */    /* include more code to the startup */
      __startup_code_end__ = .;
      *(.text .text.*)
      *(.gnu.linkonce.t.*)
      *(.glue_7)
      *(.glue_7t)
      *(.gcc_except_table)
      *(.rodata .rodata*)
      *(.gnu.linkonce.r.*)
   } > FLASH
      _etext = .;

   .data : AT (_etext)
   {
      _data = .;
      *(vtable vtable.*)
      *(.data .data.*)
      *(.gnu.linkonce.d*)
      . = ALIGN(4);
      _edata = . ;
   } > SRAM

   /* .bss section which is used for uninitialized data */
   .bss (NOLOAD) :
   {
      _bss = . ;
      *(.bss .bss.*)
      *(.gnu.linkonce.b*)
      *(COMMON)
      . = ALIGN(4);
      _ebss = . ;
   } > SRAM

   .stack (NOLOAD) :
   {
      . = ALIGN(4);
      *(.stack .stack.*)
      . = ALIGN(4);
   } > SRAM

   . = ALIGN(4);
   _end = . ;
   PROVIDE (end = .);

   /* Stabs debugging sections.  */
      .stab          0 : { *(.stab) }
      .stabstr       0 : { *(.stabstr) }
      .stab.excl     0 : { *(.stab.excl) }
      .stab.exclstr  0 : { *(.stab.exclstr) }
      .stab.index    0 : { *(.stab.index) }
      .stab.indexstr 0 : { *(.stab.indexstr) }
      .comment       0 : { *(.comment) }
   /* DWARF debug sections.
      Symbols in the DWARF debugging sections are relative to the beginning
      of the section so we begin them at 0.  */
   /* DWARF 1 */
      .debug          0 : { *(.debug) }
      .line           0 : { *(.line) }
   /* GNU DWARF 1 extensions */
      .debug_srcinfo  0 : { *(.debug_srcinfo) }
      .debug_sfnames  0 : { *(.debug_sfnames) }
   /* DWARF 1.1 and DWARF 2 */
      .debug_aranges  0 : { *(.debug_aranges) }
      .debug_pubnames 0 : { *(.debug_pubnames) }
   /* DWARF 2 */
      .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
      .debug_abbrev   0 : { *(.debug_abbrev) }
      .debug_line     0 : { *(.debug_line) }
      .debug_frame    0 : { *(.debug_frame) }
      .debug_str      0 : { *(.debug_str) }
      .debug_loc      0 : { *(.debug_loc) }
      .debug_macinfo  0 : { *(.debug_macinfo) }
   /* SGI/MIPS DWARF 2 extensions */
      .debug_weaknames 0 : { *(.debug_weaknames) }
      .debug_funcnames 0 : { *(.debug_funcnames) }
      .debug_typenames 0 : { *(.debug_typenames) }
      .debug_varnames  0 : { *(.debug_varnames) }
}
